// R_DLG.H : Radio-Dlgs
// G. TAMM, DF9ZO 2007
//--------------------
#ifndef _R_DLG_H_
#define _R_DLG_H_
//--------------------
#ifndef _R_VAR_H_
  #include "R_VAR.H"
#endif
#ifndef _R_LIB_H_
  #include "R_LIB.H"
#endif
#ifndef _R_COM_H_
  #include "R_COM.H"
#endif
#include "afxwin.h"
//--------------------
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
//ICOM_BUS_Dlg ICOM CI-V - Bus+++++++++++++++++++++++++++++++++++++++++++++++++
class ICOM_BUS_Dlg : public CDialog
{
// Construction
public:
	void TransferFrDlg(int radio);
	void TransferToDlg(int radio);
	ICOM_BUS_Dlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(ICOM_BUS_Dlg)
	enum { IDD = IDD_ICOM_BUS_DLG };
	int		m_icdata;
	int     m_filter;
    int     m_sql;
	CString	m_name;
	CString	m_icadr;
	CString	m_smconv;
	CString	m_minf;
	CString	m_maxf;
	CString	m_deff;
	CString	m_ssb_no;
	CString	m_ssb_na;
	CString	m_ssb_wi;
	CString	m_fm_no;
	CString	m_fm_na;
	CString	m_fm_wi;
	CString	m_fmw_no;
	CString	m_fmw_na;
	CString	m_fmw_wi;
	CString	m_am_no;
	CString	m_am_na;
	CString	m_am_wi;
	CString	m_cw_no;
	CString	m_cw_na;
	CString	m_cw_wi;
	CString	m_rtty_no;
	CString	m_rtty_na;
	CString	m_rtty_wi;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(ICOM_BUS_Dlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(ICOM_BUS_Dlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//FSTEPSW_Dlg++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class FSTEPSW_Dlg : public CDialog
{
// Construction
public:
	FSTEPSW_Dlg(CWnd* pParent = NULL);   // standard constructor
// Dialog Data
	//{{AFX_DATA(FSTEPSW_Dlg)
	enum { IDD = IDD_FSTEPSW_DLG };
	CString	m_Combo;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(FSTEPSW_Dlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(FSTEPSW_Dlg)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//FSTEPHW_Dlg++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class FSTEPHW_Dlg : public CDialog
{
// Construction
public:
	FSTEPHW_Dlg(CWnd* pParent = NULL);   // standard constructor
// Dialog Data
	//{{AFX_DATA(FSTEPHW_Dlg)
	enum { IDD = IDD_FSTEPHW_DLG };
	int		m_list;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(FSTEPHW_Dlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(FSTEPHW_Dlg)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//FOFFSET_Dlg++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class FOFFSET_Dlg : public CDialog
{
// Construction
public:
	FOFFSET_Dlg(CWnd* pParent = NULL);   // standard constructor
// Dialog Data
	//{{AFX_DATA(FOFFSET_Dlg)
	enum { IDD = IDD_FOFFSET_DLG };
	CString	m_Combo;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(FOFFSET_Dlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(FOFFSET_Dlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//MODE_Dlg+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class MODE_Dlg : public CDialog
{
// Construction
public:
	MODE_Dlg(CWnd* pParent = NULL);   // standard constructor
// Dialog Data
	//{{AFX_DATA(MODE_Dlg)
	enum { IDD = IDD_MODE_DLG };
	int		m_mode;
	int		m_filter;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MODE_Dlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(MODE_Dlg)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//RTTY_Dlg+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class RTTY_Dlg : public CDialog
{
	DECLARE_DYNAMIC(RTTY_Dlg)

public:
	RTTY_Dlg(CWnd* pParent = NULL);   // Standardkonstruktor
	virtual ~RTTY_Dlg();

// Dialogfelddaten
	enum { IDD = IDD_RTTY_DLG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
    virtual BOOL OnInitDialog();
	DECLARE_MESSAGE_MAP()
public:
    int m_MF;
    int m_SH;
    int m_KP;
    int m_RXDEC;
    int m_TPF;
protected:
    HACCEL      m_hAccel;    
};
//CLRMEM_Dlg ICOM CI-V - Bus+++++++++++++++++++++++++++++++++++++++++++++++++++
class CLRMEM_Dlg : public CDialog
{
public:
	CLRMEM_Dlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CLRMEM_Dlg)
	enum { IDD = IDD_CLRMEM_DLG };
	CString	m_from;
	CString	m_to;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLRMEM_Dlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
protected:

	// Generated message map functions
	//{{AFX_MSG(CLRMEM_Dlg)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//MEMBANK_Dlg ICOM CI-V - Bus++++++++++++++++++++++++++++++++++++++++++++++++++
class MEMBANK_Dlg : public CDialog
{
	DECLARE_DYNAMIC(MEMBANK_Dlg)

public:
	MEMBANK_Dlg(CWnd* pParent = NULL);   // Standardkonstruktor
	virtual ~MEMBANK_Dlg();

// Dialogfelddaten
	enum { IDD = IDD_MEMBANK_DLG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung

	DECLARE_MESSAGE_MAP()
public:    
    int m_bank;
};
//MEMCMD_Dlg ICOM CI-V - Bus+++++++++++++++++++++++++++++++++++++++++++++++++++
class MEMCMD_Dlg : public CDialog
{
	DECLARE_DYNAMIC(MEMCMD_Dlg)

public:
	MEMCMD_Dlg(CWnd* pParent = NULL);   // Standardkonstruktor
	virtual ~MEMCMD_Dlg();

// Dialogfelddaten
	enum { IDD = IDD_MEMCMD_DLG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung

	DECLARE_MESSAGE_MAP()
public:
    int m_cmd;
};
//STOPMODE_Dlg+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class STOPMODE_Dlg : public CDialog
{
public:
	STOPMODE_Dlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(STOPMODE_Dlg)
	enum { IDD = IDD_STOPMODE_DLG };
	int		m_mo;
	CString	m_ed00;
	CString	m_ed01;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(STOPMODE_Dlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:

	// Generated message map functions
	//{{AFX_MSG(STOPMODE_Dlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//ICOM_OPTIONS_Dlg+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class ICOM_OPTIONS_Dlg : public CDialog
{
	DECLARE_DYNAMIC(ICOM_OPTIONS_Dlg)

public:
	ICOM_OPTIONS_Dlg(CWnd* pParent = NULL);   // Standardkonstruktor
	virtual ~ICOM_OPTIONS_Dlg();

// Dialogfelddaten
	enum { IDD = IDD_ICOM_OPTIONS_DLG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung

	DECLARE_MESSAGE_MAP()
public:
    int     m_SM_sel;
    int     m_SQLSM_cont;
    int     m_conf;
    CString m_delay;
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#endif // _R_DLG_H_
