// R_LIB.CPP : Funktionen f. Radio
// G. TAMM, DF9ZO 1999
//--------------------
#ifndef _R_LIB_H_
  #include "R_LIB.H"
#endif
//+Allgemeine Funktionen+++++++++++++++++++++++++++++++++++++++++++++++++++++++
void ModFstr(char *freq,char *freqdef)
{
 int error=0,le,diff,count=0,poscomma=0,pospunct=0;

 //Fuehrende u. anhaengende Leerzeichen u. Nullen entfernen
 StrTrLe(freq,' ');StrTrLe(freq,'0');StrTrRi(freq,' ');
 //Zulaessige Zeichen:'0'..'9' / ein '.' / ein ','
 while (*(freq+count) != '\0')
  {
   if (!isdigit(*(freq+count)) && *(freq+count) != '.' && *(freq+count) != ',')
      error++;
   if (*(freq+count) == '.') pospunct++;
   if (*(freq+count) == ',') poscomma++;
   count++;
  }
 if (error || pospunct > 1 || poscomma >1 || strlen(freq) == 0)
    {strcpy(freq,freqdef);return;}
 //Stellenzahl vor Punkt bzw. Gesanmtlaenge bei keinem Punkt
 le=strlen(freq);pospunct=StrChPos(freq,'.',0);
 if (pospunct > 4 || ((pospunct < 0) && (le > 4)))
	{strcpy(freq,freqdef);return;}
 //Punkt erkennen und ggf. anhaengen
 if (pospunct < 0) strcat(freq,".");
 //Test auf Komma vor Punkt, Zwischenraum zwischen Punkt und Komma
 le=strlen(freq);pospunct=StrChPos(freq,'.',0);poscomma=StrChPos(freq,',',0);
 if (poscomma > -1 && pospunct > -1)
  {
   diff=poscomma-pospunct;
   if (pospunct > poscomma || diff != 4) {strcpy(freq,freqdef);return;}
  }
 //Test auf Stellen nach Punkt, wenn kein Komma
 if (poscomma < 0 && pospunct > -1)
  {
   diff=le-pospunct;
   if (diff > 4) {strcpy(freq,freqdef);return;}
  }
 //Test auf Stellen nach Komma
 if (poscomma > 0)
  {
   diff=le-poscomma;
   if (diff > 4) *(freq+poscomma+4)='\0';
  }
 //Nullen nach Punkt anhaengen
 pospunct=StrChPos(freq,'.',0);le=strlen(freq);diff=le-pospunct;
 switch (diff) 
  {
   case 1:strcat(freq,"000");break;
   case 2:strcat(freq,"00");break;
   case 3:strcat(freq,"0");break;
   case 4:break;
  }
 //Nullen nach Komma anhaengen
 poscomma=StrChPos(freq,',',0);if (poscomma < 0) strcat(freq,",");
 le=strlen(freq);poscomma=StrChPos(freq,',',0);diff=le-poscomma;
 switch (diff) 
  {
   case 1:strcat(freq,"000");break;
   case 2:strcat(freq,"00");break;
   case 3:strcat(freq,"0");break;
   case 4:break;
  }
 StrFiLe(freq,' ',RStrLf-1);
}
//-----------------------------------------------------------------------------
int ChCorrFstart(const char *freq)
{
 char str[RStrLf];

 strcpy(str,freq);StrTrLe(str,' ');
 if (str[0]=='0'||str[0]=='1'||str[0]=='2'||str[0]=='3'||str[0]=='4'||
 	  str[0]=='5'||str[0]=='6'||str[0]=='7'||str[0]=='8'||str[0]=='9'||
     str[0]=='.') return 1;
     else return 0;
}
//-----------------------------------------------------------------------------
unsigned int FstrToFnum(const char *freqstr)
{
 char tmpstr[RStrLf];
 int pos;

 strcpy(tmpstr,freqstr);
 StrTrLe(tmpstr,' ');
 pos=StrChPos(tmpstr,'.',0);StrDelChPos(tmpstr,pos);
 pos=StrChPos(tmpstr,',',0);StrDelChPos(tmpstr,pos);
 return (unsigned int)strtol(tmpstr,0,10);
}
//-----------------------------------------------------------------------------
void FnumToFstr(char *freqstr,int freqnum)
{
 int le;

 ultoa(freqnum,freqstr,10);le=strlen(freqstr);
 switch (le) {
   case  6:StrInsChPos(freqstr,'.',0);StrInsChPos(freqstr,',',4);break;
   case  7:StrInsChPos(freqstr,'.',1);StrInsChPos(freqstr,',',5);break;
   case  8:StrInsChPos(freqstr,'.',2);StrInsChPos(freqstr,',',6);break;
   case  9:StrInsChPos(freqstr,'.',3);StrInsChPos(freqstr,',',7);break;
   case 10:StrInsChPos(freqstr,'.',4);StrInsChPos(freqstr,',',8);break;
   case  5:StrStrIns(freqstr,".0",0);StrInsChPos(freqstr,',',4);break;
   case  4:StrStrIns(freqstr,".00",0);StrInsChPos(freqstr,',',4);break;
   case  3:StrStrIns(freqstr,".000,",0);break;
   case  2:StrStrIns(freqstr,".000,0",0);break;
   case  1:StrStrIns(freqstr,".000,00",0);break;
   case  0:StrStrIns(freqstr,".000,000",0);break;
  }
 StrFiLe(freqstr,' ',RStrLf-1);
}

void SetActToLast()
{
 strcpy(Flas_s,Fact_s);
 Mlas_n=Mact_n; 
 FIlas_n=FIact_n;
}
//+Funktionen z. Modifikation ModeStr, FilterStr, AttStr, usw.+++++++++++++++++
void ModMstr(char *mode)
{
 StrTrRi(mode,' ');StrFiRi(mode,' ',MaxMOsLe);
 for (int x=0;x<MaxMOs;x++)
  {
   if (strcmpi(mode,MOs[x]) == 0) 
    {
     strcpy(mode,MOs[x]);
     Mact_n=x;
     strcpy(Mact_s,MOs[x]);
     return;
    }
  }
 strcpy(mode,Mdef_s);Mact_n=4;
}

int MstrToMnum(char *mode)
{
 ModMstr(mode);
 return Mact_n;
}

void MnumToMstr(int num,char *mode)
{
 strcpy(mode,MOs[num]);
}
//-----------------------------------------------------------------------------
void ModFIstr(char *fi)
{
 StrTrRi(fi,' ');
 StrFiRi(fi,' ',MaxFIsLe);
 for (int x=0;x<MaxFIs;x++)
  {
   if (strcmpi(fi,FIs[x]) == 0) 
    {
     strcpy(fi,FIs[x]);
     FIact_n=x;
     strcpy(FIact_s,FIs[x]);
     return;
    }
  }
 strcpy(fi,FIs[0]);FIact_n=0;
}

int FIstrToFInum(char *fi)
{
 ModFIstr(fi);
 return FIact_n;
}

void FInumToFIstr(int num,char *fi)
{
 strcpy(fi,FIs[num]);
}
//-----------------------------------------------------------------------------
int SFstrToSFind(char *fstep)
{
 if (strcmp(fstep,".000,010") == 0) return 0;
 if (strcmp(fstep,".000,100") == 0) return 1;
 if (strcmp(fstep,".001,000") == 0) return 2;
 if (strcmp(fstep,".005,000") == 0) return 3;
 if (strcmp(fstep,".009,000") == 0) return 4;
 if (strcmp(fstep,".010,000") == 0) return 5;
 if (strcmp(fstep,".012,500") == 0) return 6;
 if (strcmp(fstep,".020,000") == 0) return 7;
 if (strcmp(fstep,".025,000") == 0) return 8;
 if (strcmp(fstep,".100,000") == 0) return 9;
 return 2;
}
//-----------------------------------------------------------------------------
void SetSMstr(int sm,int mode)
{      
 if (mode == 0) {itoa(SMlev_n,SMlev_s,10);return;}

 if (sm > SM_li_n[14]) {strcpy(SMlev_s,SM_li_s[14]);return;}
 if (sm > SM_li_n[13]) {strcpy(SMlev_s,SM_li_s[13]);return;}
 if (sm > SM_li_n[12]) {strcpy(SMlev_s,SM_li_s[12]);return;}
 if (sm > SM_li_n[11]) {strcpy(SMlev_s,SM_li_s[11]);return;}
 if (sm > SM_li_n[10]) {strcpy(SMlev_s,SM_li_s[10]);return;}
 if (sm > SM_li_n[ 9]) {strcpy(SMlev_s,SM_li_s[9]) ;return;}
 if (sm > SM_li_n[ 8]) {strcpy(SMlev_s,SM_li_s[8]) ;return;}
 if (sm > SM_li_n[ 7]) {strcpy(SMlev_s,SM_li_s[7]) ;return;}
 if (sm > SM_li_n[ 6]) {strcpy(SMlev_s,SM_li_s[6]) ;return;}
 if (sm > SM_li_n[ 5]) {strcpy(SMlev_s,SM_li_s[5]) ;return;}
 if (sm > SM_li_n[ 4]) {strcpy(SMlev_s,SM_li_s[4]) ;return;}
 if (sm > SM_li_n[ 3]) {strcpy(SMlev_s,SM_li_s[3]) ;return;}
 if (sm > SM_li_n[ 2]) {strcpy(SMlev_s,SM_li_s[2]) ;return;}
 if (sm > SM_li_n[ 1]) {strcpy(SMlev_s,SM_li_s[1]) ;return;}
 if (sm > SM_li_n[ 0]) {strcpy(SMlev_s,SM_li_s[0]) ;return;}
 if (sm >= 0)          {strcpy(SMlev_s,"-");return;}
}
//+Scan-Funktionen+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int MakeAndCheckScanPars(int mode,char *memscfi)
{
 CStdioFile     F_In;
 CFileException F_Exc;
 char           DiskL[RStrLt],destf[RStrLf],destm[RStrLm];
 unsigned int   F;
 int            err,ind;
 
 ScLiNum=0;
 ModFstr(ScLoF_s,Fdef_s);ScLoF_n=FstrToFnum(ScLoF_s);
 ModFstr(ScHiF_s,Fdef_s);ScHiF_n=FstrToFnum(ScHiF_s);
 ModFstr(SFact_s,SFdef_s);SFact_n=FstrToFnum(SFact_s);
 ModFstr(IRADIO_IB[Radio_Num].Fmin_s,Fdef_s);Fmin_n=FstrToFnum(IRADIO_IB[Radio_Num].Fmin_s);
 ModFstr(IRADIO_IB[Radio_Num].Fmax_s,Fdef_s);Fmax_n=FstrToFnum(IRADIO_IB[Radio_Num].Fmax_s);
 for (ind=0;ind < ScLiMax;ind++)
  {
   ScAr.f[ind][0]='\0';ScAr.m[ind]=0;ScAr.y[ind]=0;
  }
 err=0;ind=-1;
 if (mode == 0)//SCAN
  {
   if (ScLoF_n >= ScHiF_n  || (ScHiF_n-ScLoF_n)/SFact_n > ScLiMax ||
       ScLoF_n <  Fmin_n   || ScHiF_n > Fmax_n) return -1;
   F=ScLoF_n;ind=0;
   while (F <= ScHiF_n && ind < ScLiMax)
    {
     FnumToFstr(ScAr.f[ind],F);ScAr.m[ind]=Mact_n;
     F+=SFact_n;ind++;ScLiNum++;
    }
  }
 if (mode == 1)//M-SCAN            
  {
   if(!F_In.Open(memscfi,CFile::modeRead | CFile::typeText,&F_Exc)) 
    {
     //MessageBox(0,"ERROR file (R_Lib:MakeAndCheckScanPars)","",MB_ICONSTOP | MB_OK);
    }else
    {
     while (F_In.ReadString(DiskL,RStrLt-2) != 0)
      {
       StrDel_CR_LF(DiskL);

	   if (DiskL[0] == '\0' || DiskL[0] == ';' || DiskL[0] == '[') continue;
       DiskL[RStrLt-3]=0;
       GetFM(destf,destm,DiskL);
       if (ChCorrFstart(destf) == 0) continue;
       ModFstr(destf,Fdef_s);F=FstrToFnum(destf);
       if (F <  Fmin_n || F > Fmax_n || ind+1 == ScLiMax) {err=1;continue;}
       ModMstr(destm);
       ind++;ScLiNum++;
       strcpy(ScAr.f[ind],destf);ScAr.m[ind]=Mact_n;
      }
     F_In.Close();
     if (err == 1 || ind == -1) return -2;
    }
  }
 return 1;
}
//+Allgemeine Funktionen+++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RadioSettings()
{
 int x;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  { 
   IRadio_IB_Adr_n =IB_HexStrToInt(IRADIO_IB[Radio_Num].IB_Adr_s);
   IRadio_IB_Da_n  =IRADIO_IB[Radio_Num].IB_Da_n;
   IRadio_IB_SQL_n =IRADIO_IB[Radio_Num].SQL_SH;
   IRadio_IB_DSP_Fi=IRADIO_IB[Radio_Num].IB_DSP_Fi;

   if (IRadio_IB_DSP_Fi == 0)//HW-Filter
    {
     for (x=0;x < 18;x++)
      {
       if (IRADIO_IB[Radio_Num].IB_Fi_s[x][0] == '\0') IRadio_IB_Fi_n[x]=-1;
           else IRadio_IB_Fi_n[x]=IB_HexStrToInt(IRADIO_IB[Radio_Num].IB_Fi_s[x]);
      }
    }else                    //DSP-Filter
    {
    }
  }
}
//-----------------------------------------------------------------------------
void GetFM(char *destf,char *destm,char *src)
{
 StrCopy(destf,src,RStrSf,RStrLf-1);destf[RStrLf]=0;
 StrCopy(destm,src,RStrSm,RStrLm-1);destm[RStrLm]=0;
 return; 
}
//-----------------------------------------------------------------------------
int GetAddRemData(char *src,int what)
{
 int  posa,pose,lekey;
 char tre=';';
 char tmpstr[500];

 src[RStrLr]=0;
 posa=StrStrFiPos(src,RadAdds_s[what]);
 if (posa > -1)
  {
   lekey=strlen(RadAdds_s[what]);
   pose=StrChPos(src,tre,posa+lekey);
   if (pose > -1)
    {
     if (what == 0)// SF
      {
       StrCopy(SFact_s,src,posa+lekey,pose-posa-lekey);
       ModFstr(SFact_s,SFdef_s);SFact_n=FstrToFnum(SFact_s);
      }
     if (what == 1)// OF
      {
       StrCopy(OFact_s,src,posa+lekey,pose-posa-lekey);
       ModFstr(OFact_s,SFdef_s);OFact_n=FstrToFnum(OFact_s);
      }
     if (what == 2)// FI
      {
       StrCopy(tmpstr,src,posa+lekey,pose-posa-lekey);
       FIact_n=0;strcpy(FIact_s,FIs[FIact_n]);
       ModFIstr(tmpstr);
      }
     if (what == 3)// ATT
      {
       ATTsw=0;
       StrCopy(tmpstr,src,posa+lekey,pose-posa-lekey);
       ATTsw=atoi(tmpstr);
      }
     if (what == 4)// DUP
      {
       DUPsw=0;
       StrCopy(tmpstr,src,posa+lekey,pose-posa-lekey);
       if (tmpstr[0] == 'S') DUPsw=0;
       if (tmpstr[0] == '-') DUPsw=1;
       if (tmpstr[0] == '+') DUPsw=2;       
      }
     if (what == 5)// PAMP
      {
       PAMPsw=0;
       StrCopy(tmpstr,src,posa+lekey,pose-posa-lekey);
       PAMPsw=atoi(tmpstr);
      }
     if (what == 6)// TXT
      {
       StrCopy(tmpstr,src,posa+lekey,pose-posa-lekey);
       strcpy(MEMtxt_s,tmpstr);
      }
     return 1;
    }
  }
 return 0;
}
//-----------------------------------------------------------------------------
void CombineRemStr(char *dest,char *rstr)
{
 char tmpstr[RStrLf];

 //-SF-------------------
 strcpy(dest,RadAdds_s[0]);
 strcpy(tmpstr,SFact_s);
 StrTrLe(tmpstr,' ');StrTrRi(tmpstr,'0');StrTrRi(tmpstr,',');StrTrRi(tmpstr,'0');
 strcat(dest,tmpstr);strcat(dest,";");
 //-OF-------------------
 strcat(dest,RadAdds_s[1]);
 strcpy(tmpstr,OFact_s);
 StrTrLe(tmpstr,' ');StrTrRi(tmpstr,'0');StrTrRi(tmpstr,',');StrTrRi(tmpstr,'0');
 strcat(dest,tmpstr);strcat(dest,";");
 //-FI-------------------
 strcat(dest,RadAdds_s[2]);
 strcat(dest,FIact_s);
 strcat(dest,";");
 //-ATT------------------
 strcat(dest,RadAdds_s[3]);
 itoa(ATTsw,tmpstr,10);strcat(dest,tmpstr);
 strcat(dest,";");
 //-Remark---------------
 strcat(dest,rstr);strcat(dest,"\n");
}
//-----------------------------------------------------------------------------
void CombineRadStr(char *dest,char *rstr)
{
 char tmpstr[RStrLm];

 strcpy(dest,Fact_s);ModFstr(dest,Fdef_s);strcat(dest," ");
 //------------------------------
 strcpy(tmpstr,Mact_s);ModMstr(tmpstr);strcat(dest,tmpstr);
 StrFiRi(dest,' ',RStrLf+RStrLm);
 //------------------------------
 strcat(dest,rstr);
}
//+ICOM_BUS-Funktionen+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int IB_HexStrToInt(char *src)
{
 char str[6]="0x";
 
 strcat(str,src);
 return strtol(str,0,16);
}
//-----------------------------------------------------------------------------
void IB_HexToDecStr(char *dest,int data)
{
 itoa(data,dest,16);
 if (dest[1]=='\0')
  {
   dest[2]='\0';dest[1]=dest[0];dest[0]='0';
  }
}
//-----------------------------------------------------------------------------
void IB_DecToBCD(int &hi,int &lo,int dec)
{
 int loo;
 //char str[20];

 hi=dec / 100;
 lo=dec % 100;loo=lo % 10;
 lo/=10;lo<<=4;
 lo=lo | loo;//itoa(lo,str,2);
}

int  IB_BCDtoDec(int hi,int lo)
//Wandelt BCD-Format in dec, hi=1, lo=153 -> dec=199
{
 char str[4];
 int res=hi*100;

 itoa(lo,str,16);
 return res+=atoi(str);
}
//-----------------------------------------------------------------------------
void IB_FreqToSend(int dest[],char *freq)
{
 int x,y,res;
 char str[5];

 res=StrChPos(freq,'.',0);StrDelChPos(freq,res);
 res=StrChPos(freq,',',0);StrDelChPos(freq,res);
 StrReplAllCh(freq,' ','0',0);
 //----------------------
 for (x=0,y=8;x<5;x++,y-=2)
  {
   str[0]=freq[y];str[1]=freq[y+1];str[2]=0;
   dest[x]=strtol(str,0,16);
  }
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void R_Lib_Init()
{
 int le,x;
 //MaxMOsLe---------------------------------
 MaxMOsLe=0;
 for(x=0;x < MaxMOs;x++)
  {
   le=strlen(MOs[x]);if (le > MaxMOsLe) MaxMOsLe=le; 
  }
 for(x=0;x < MaxMOs;x++) StrFiRi(MOs[x],' ',MaxMOsLe);
 //MaxFIsLe---------------------------------
 MaxFIsLe=0;
 for(x=0;x < MaxFIs;x++)
  {
   le=strlen(FIs[x]);if (le > MaxFIsLe) MaxFIsLe=le; 
  }
 for(x=0;x < MaxMOs;x++) StrFiRi(FIs[x],' ',MaxFIsLe);
 //Diverses---------------------------------
 StrFiLe(Fdef_s,' ',RStrLf); 
 StrFiLe(SFdef_s,' ',RStrLf); 
 StrFiLe(OFdef_s,' ',RStrLf); 

 StrFiRi(Mdef_s,' ',MaxMOsLe);
 StrFiRi(Mlas_s,' ',MaxMOsLe);
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
