// TaICOM.h:
// G.Tamm,DF9ZO 2007
//------------------
#ifndef _TAICOM_H_
#define _TAICOM_H_
//------------------
#ifndef _TA_STDAFX_H_
  #include "stdafx.h"
#endif
//------------------
#ifndef _R_VAR_H_
  #include "R_VAR.H"
#endif
#ifndef _R_DLG_H_
  #include "R_DLG.H"
#endif
#ifndef _R_REM_H_
  #include "R_REM.H"
#endif
#ifndef _R_SCAN_H_
  #include "R_SCAN.H"
#endif
//-----------------------------------------------------------------------------
#if _MSC_VER >=1000
 #pragma once
#endif

#ifndef __AFXWIN_H__
 #error include 'stdafx.h' before including this file for PCH
#endif
//CTheApp++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class CTheApp : public CWinApp
{
public:
	virtual BOOL InitInstance();
    BOOL OnIdle(LONG lCount);
	//{{AFX_MSG( CTheApp )
    afx_msg void OnFilePrintSetup();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//CMainWindow++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class CMainWindow : public CFrameWnd
{
public:
	CMainWindow();
    //Diagnose----
   #ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const;
   #endif
   //------------
protected:
    virtual   ~CMainWindow(); 
	TaStatBar m_wndStatusBar;
	//-------------------
    //afx_msg LRESULT OnMyMessage(WPARAM wParam,LPARAM lParam);
	//-------------------
	//{{AFX_MSG( CMainWindow )
	afx_msg void OnPaint();
	afx_msg void OnClose();
	afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void On_M_About();
	afx_msg void On_M_Info();
	afx_msg void On_M_Exit();
	afx_msg void On_M_Radio1();
	afx_msg void On_M_Radio2();
	afx_msg void On_M_Radio3();
	afx_msg void On_M_Radio4();
	afx_msg void On_M_RadioPar1();
	afx_msg void On_M_RadioPar2();
	afx_msg void On_M_RadioPar3();
	afx_msg void On_M_RadioPar4();
	afx_msg void On_M_Rem();
    afx_msg void On_M_Scan();
	afx_msg void On_M_COM_Settings();
	afx_msg void On_M_COM_ChPorts();
	afx_msg void On_M_COM_ClrRXBuf();
	afx_msg void On_M_ShowInfo();
	afx_msg void On_M_ICOMBUS_ResMem();
    afx_msg void On_M_ICOMBUS_SetMem();
    afx_msg void On_M_ICOMBUS_Options();
	afx_msg void On_ID_Test();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
    HICON icon;
    int   SchrH,SchrB;

	int  XOpos,YOpos;			//Bildschirmpos. Fenster links  oben (AUSSEN)
	int  XUpos,YUpos;			//Bildschirmpos. Fenster rechts unten(AUSSEN)
	int  XIOpos,YIOpos;			//Bildschirmpos. Fenster links  oben (CLIENT-BER.)
	int  XIUpos,YIUpos;			//Bildschirmpos. Fenster rechts unten(CLIENT-BER.)	
    int  Hcaption,Hmenue;		//Hoehe Titelleiste,Menueleiste
	int  Dvframe,Dhframe;		//Dicke vert./hor. Rahmen
    int  BVScr,HHScr;           //Breite vert. Scr/Hoehe hor. Scr

	void GetWinPars();
    void UpDateStatusStr(int mode);
    void UpDateStatusBar();
    int  GetCOMAnswer(int retexp);    
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#endif // _TAICOM_H_
